{                          EDCMDS.INC
                       Editor Toolbox 4.0
             Copyright (c) 1985, 87 by Borland International, Inc.            }

type
  CommandType =
  (

   {Basic cursor movements}
   CmdLeftChar,              {0. Left character}
   CmdRightChar,             {1. Right character}
   CmdLeftWord,              {2. Left lexeme}
   CmdRightWord,             {3. Right lexeme}
   CmdUpLine,                {4. Up line}
   CmdDownLine,              {5. Down line}
   CmdScrollUp,              {6. Scroll up}
   CmdScrollDown,            {7. Scroll down}
   CmdDownPage,              {8. Down page}
   CmdUpPage,                {9. Up page}

   {Quick movements}
   CmdWindowTopFile,         {10. Top of window}
   CmdWindowBottomFile,      {11. Bottom of window}
   CmdLeftLine,              {12. Cursor to left side}
   CmdRightLine,             {13. Cursor to right side}
   CmdTopScreen,             {14. Top of screen}
   CmdBottomScreen,          {15. Bottom of screen}
   CmdUnused1,               {for expansion}
   CmdUnused2,               {for expansion}
   CmdCpgotoln,              {18. Goto line n}
   CmdGotoColumn,            {19. Goto column n}
   CmdUnused3,               {for expansion}
   CmdJumpLastPosition,      {21. Previous cursor position}

   {Insertion and deletion}
   CmdUndo,                  {22. Undo last deletion}
   CmdRestoreCurrentLine,    {23. Restore line as on entry}
   CmdTab,                   {24. Tab, either fixed or "smart"}
   CmdInsertCtrlChar,        {25. Inserting control character into text}
   CmdNewLine,               {26. New line in text buffer}
   CmdInsertLine,            {27. Inserting line}
   CmdDeleteRightChar,       {28. Delete current character}
   CmdDeleteLeftChar,        {29. Delete left character}
   CmdDeleteRightWord,       {30. Delete right lexeme}
   CmdDeleteLineRight,       {31. Delete line right of cursor}
   CmdDeleteLine,            {32. Delete line}
   CmdUnused4,               {for expansion}

   {Find and replace}
   CmdFind,                  {34. Find pattern}
   CmdFindReplace,           {35. Find and replace}
   CmdUnused5,               {for expansion}
   CmdFindNext,              {37. Find next}

   {Files and DOS interface}
   CmdUnused6,               {for expansion}
   CmdUnused7,               {for expansion}
   CmdUnused8,               {for expansion}
   CmdAbandonFile,           {41. Abandon file}
   CmdReadBlock,             {42. Read file into window}
   CmdSaveFile,              {43. Save file}
   CmdWriteBlock,            {44. Write block to file, not appending}
   CmdSaveQuit,              {45. Save file and exit}

   {Windows}
   CmdAddWindow,             {46. Add second window with same or different file}
   CmdSizeWindow,            {47. Resize current window}
   CmdUnused9,               {for expansion}
   CmdWindowDown,            {49. Switch windows}
   CmdUnused10,              {for expansion}
   CmdUnused11,              {for expansion}

   {Blocks}
   CmdBlockBegin,            {52. Begin block}
   CmdBlockEnd,              {53. End block}
   CmdJumpTopOfBlock,        {54. Top of block}
   CmdJumpBottomBlock,       {55. Bottom of block}
   CmdBlockCopy,             {56. Copy block}
   CmdBlockMove,             {57. Move block}
   CmdBlockDelete,           {58. Delete block}
   CmdBlockHide,             {59. Hide/display toggle block}
   CmdBlockWord,             {60. Mark current word as block}

   {Text markers}
   CmdToggleTextMarker,      {61. Toggle text marker display}
   CmdSetMarker0,            {62. Set marker}
   CmdSetMarker1,
   CmdSetMarker2,
   CmdSetMarker3,
   CmdSetMarker4,
   CmdSetMarker5,
   CmdSetMarker6,
   CmdSetMarker7,
   CmdSetMarker8,
   CmdSetMarker9,
   CmdJumpMarker0,           {Jump marker}
   CmdJumpMarker1,
   CmdJumpMarker2,
   CmdJumpMarker3,
   CmdJumpMarker4,
   CmdJumpMarker5,
   CmdJumpMarker6,
   CmdJumpMarker7,
   CmdJumpMarker8,
   CmdJumpMarker9,

   CmdUnused12,              {for expansion}
   CmdUnused13,              {for expansion}
   CmdUnused14,              {for expansion}
   CmdUnused15,              {for expansion}
   CmdUnused16,              {for expansion}
   CmdUnused17,              {for expansion}
   CmdUnused18,              {for expansion}
   CmdUnused19,              {for expansion}
   CmdUnused20,              {for expansion}
   CmdUnused21,              {for expansion}
   CmdUnused22,              {for expansion}
   CmdUnused23,              {for expansion}
   CmdUnused24,              {for expansion}
   CmdUnused25,              {for expansion}
   CmdUnused26,              {for expansion}
   CmdUnused27,              {for expansion}
   CmdUnused28,              {for expansion}
   CmdUnused29,              {for expansion}
   CmdUnused30,              {for expansion}
   CmdUnused31,              {for expansion}
   CmdUnused32,              {for expansion}
   CmdUnused33,              {for expansion}

   {Toggles and status}
   CmdSysInfo,               {104. Show system information}
   CmdShowMem,               {105. Show available memory}
   CmdToggleInsert,          {106. Toggle insert mode}
   CmdToggleAutoindent,      {107. Toggle autoindent mode}

   CmdUnused34,              {for expansion}
   CmdUnused35,              {for expansion}
   CmdUnused36,              {for expansion}
   CmdUnused37,              {for expansion}
   CmdUnused38,              {for expansion}
   CmdUnused39,              {for expansion}
   CmdUnused40,              {for expansion}
   CmdUnused41,              {for expansion}
   CmdUnused42,              {for expansion}
   CmdUnused43,              {for expansion}
   CmdUnused44,              {for expansion}
   CmdUnused45,              {for expansion}
   CmdUnused46,              {for expansion}
   CmdUnused47,              {for expansion}
   CmdUnused48,              {for expansion}

   {Utility Commands}
   CmdUnused49,              {for expansion}
   CmdUnused50,              {for expansion}
   CmdUnused51,              {for expansion}
   CmdUnused52,              {for expansion}
   CmdLogDrive,              {127. Log drive or path}
   CmdUnused53,              {for expansion}

   {Additional commands}
   CmdUnused54,              {for expansion}
   CmdUnused55,              {for expansion}
   CmdUnused56,              {for expansion}
   CmdUnused57,              {for expansion}
   CmdSetUndoLimit,          {133. Set default undo limit}
   CmdUnused58,              {for expansion}
   CmdGetDefaultExtension,   {135. Get a new default file extension}

   CmdUnused59,              {for expansion}
   CmdUnused60,              {for expansion}
   CmdUnused61,              {for expansion}
   CmdUnused62,              {for expansion}
   CmdUnused63,              {for expansion}
   CmdUnused64,              {for expansion}
   CmdUnused65,              {for expansion}

   CmdUnused66,              {for expansion}
   CmdUnused67,              {for expansion}
   CmdUnused68,              {for expansion}
   CmdUnused69,              {for expansion}
   CmdUnused70,              {for expansion}
   CmdUnused71,              {for expansion}
   CmdUnused72,              {for expansion}
   CmdUnused73,              {for expansion}
   CmdWriteNamedFile,        {151. Save current window to another file}

   CmdUnused74,              {for expansion}
   CmdWindowUp,              {153. Move to previous window}
   CmdUnused75,              {for expansion}
   CmdUnused76,              {for expansion}
   CmdUnused77,              {for expansion}
   CmdUnused78,              {for expansion}
   CmdUnused79,              {for expansion}
   CmdUnused80,              {for expansion}
   CmdUnused81,              {for expansion}
   CmdUnused82,              {for expansion}
   CmdUnused83,              {for expansion}
   CmdUnused84,              {for expansion}
   CmdUnused85,              {for expansion}
   CmdUnused86,              {for expansion}
   CmdUnused87,              {for expansion}
   CmdUnused88,              {for expansion}
   CmdUnused89,              {for expansion}
   CmdUnused90,              {for expansion}

   CmdUnused91,              {for expansion}
   CmdUnused92,              {for expansion}
   CmdUnused93,              {for expansion}
   CmdUnused94,              {for expansion}

   CmdUnused95,              {for expansion}
   CmdUnused96,              {for expansion}
   CmdUnused97,              {for expansion}
   CmdUnused98,              {for expansion}
   CmdUnused99,              {for expansion}
   CmdUnused100,             {for expansion}
   CmdUnused101,             {for expansion}
   CmdUnused102,             {for expansion}
   CmdUnused103,             {for expansion}
   CmdUnused104,             {for expansion}
   CmdUnused105,             {for expansion}
   CmdUnused106,             {for expansion}
   CmdUnused107,             {for expansion}
   CmdUnused108,             {for expansion}
   CmdUnused109,             {for expansion}
   CmdUnused110,             {for expansion}
   CmdUnused111,             {for expansion}
   CmdUnused112,             {for expansion}

   {These should be kept last}
   CmdAbort,                 {192. Abort current operation}
   CmdNull,                  {193. No operation indicated}
   CmdNullMain               {194. No op indicated, submenu accessible with no file open}
   );
