{                          EDIVARS.INC
                           EDINST 4.0
             Copyright (c) 1985, 87 by Borland International, Inc.            }

const
  Version = '4.00A';         {installation program version number}
  ProgName = 'ED.EXE';       {name of editor}
  NameLength = 26;           {Maximum length title for command}
  CmdListBytes = 512;        {Maximum Number of bytes of installable commands}

type
  String255 = string[255];
  FilePath = string[64];
  CommandName = string[NameLength];
  CommandString = string[4];
  PackedCommandList = array[0..CmdListBytes] of Char;

  CommandRec =
  record
    Name : CommandName;
    Main : KeyRec;
    Alt : KeyRec;
  end;

  CommandList = array[CommandType] of CommandRec;

  {Color type for installation}
  ColorType = (              {Screen colors}
               TxtColor,     {Text color}
               BlockColor,   {Block color}
               BordColor,    {Window status lines}
               CmdColor,     {Command line color}
               CursorColor,  {Color for solid block cursor, if activated}
               MnColor,      {Normal menu color}
               MfColor,      {Menu frame color}
               MsColor,      {Selected menu item color}
               MhColor,      {Highlighted selection character in menu}
               BoldColor,    {Color for bold attribute}
               DblColor,     {Color for doublestrike attribute}
               UndColor,     {Color for underscore attribute}
               SupColor,     {Color for superscript attribute}
               SubColor,     {Color for subscript attribute}
               Alt1Color,    {Color for alternate 1 attribute - Compressed}
               Alt2Color     {Color for alternate 2 attribute - Italic}
               );

  {Stores screen attributes}
  AttributeArray = array[ColorType] of Byte;

  MInstallRec =              {Must match order of installation area in EDVARS.PAS}
  record
    SaveUndoLimit : Integer;
    DefExtension : string[3];
    SaveInsertMode : Boolean;
    SaveIndentMode : Boolean;
  end;

  SInstallRec =              {Must match order of installation area in SCRN.PAS}
  record
    MonoAttr : AttributeArray;
    ColorAttr : AttributeArray;
    GoodColorCard : Boolean;
  end;

const

  {Marks start of INSTALLATION AREA}
  MIDstring : string[22] = 'MAIN INSTALLATION AREA';

  {Marks start of KEYBOARD INSTALLATION AREA}
  KIDstring : string[26] = 'KEYBOARD INSTALLATION AREA';

  {Marks start of SCREEN INSTALLATION AREA}
  SIDstring : string[24] = 'SCREEN INSTALLATION AREA';

var
  Commands, OrigCommands : CommandList;
  MainDefaults : MInstallRec;
  ScreenDefaults : SInstallRec;
  WP : WindowPtr;
